#ifndef __TControlFunctions_
#define	__TControlFunctions_

#include "globalDef.h"
#include "TMySQLClient.h"

#include "TObject.h"
#include "TFile.h"
#include "TTree.h"
#include "TSQLResult.h"

#include <sstream>
#include <fstream>
#include <stdio.h>
#include <iostream>
#include <string>

#define SQL_TABLE_MAX_COLUMN     10
#define SQL_TABLE_MAX_CHAR_FIELD 30
#define MAX_TCP_MSG_LEN          4000

class TControlFunctions : public TObject {

	struct FileInfo_t {
      Float_t version;
      Float_t year;
      Float_t month;
      Float_t hour;
      Float_t minute;
      Float_t second;
      Char_t dbname[30];
	};
    public:	  
		TMySQLClient* sqlclient;  	// Connection to the MySQL server
		TFile* rootFile;    	    // Pointer to the ROOT database
		TTree* treeSqlDb;          	// MySQL database tree

	public: 
		TControlFunctions();
		~TControlFunctions();

	public:	
		int TControlFunctions::Init();
		void TControlFunctions::SaveRootFile();

	private:
		TTree* treeFileInfo;       // File information tree
		FileInfo_t thisFileInfo;   // File info structure
	
		// variables to store the values from the result table
		Char_t paramName[SQL_TABLE_MAX_CHAR_FIELD];     // Field 0 = parameter name
		Char_t paramDescript[SQL_TABLE_MAX_CHAR_FIELD]; // Field 1 = parameter description
		Char_t pktName[SQL_TABLE_MAX_CHAR_FIELD];       // Field 2 = paketname
		Int_t  wordNb;                                  // Field 3 = word number
		Int_t  bitOffset;                               // Field 4 = bit offset
		Int_t  size;                                    // Field 5 = size
		Char_t type[SQL_TABLE_MAX_CHAR_FIELD];          // Field 6 = type
		Char_t unit[SQL_TABLE_MAX_CHAR_FIELD];          // Field 7 = unit
		Int_t  apid;                                    // Field 8 = apid
		Int_t  pktId;                                   // Field 9 = pktId
	
	private:
		int TControlFunctions::InitRootFile();
		int TControlFunctions::InitParamTable();
		
	ClassDef(TControlFunctions,0)
};
#endif
