#include "globalDef.h"
#include "TMySQLClient.h"
#include "TSQLResult.h"
#include "TSQLRow.h"
#include "TSQLServer.h"

#include <iostream>
#include <sstream>

#define DEBUG_MSG 1

using namespace std;

ClassImp(TMySQLClient)


//______________________________________________________________________________
TMySQLClient::TMySQLClient(string host, string dbname, string usr, string pwd) {
   // TTmapClient constructor.
   this->sqlserv = NULL;
   this->isConnected = FALSE;
   this->mysqlserverhost = host;
   this->dbname = dbname;
   this->usr = usr;
   this->pwd = pwd;
}


//______________________________________________________________________________
TMySQLClient::~TMySQLClient() {
   // TTmapClient destructor.

}


//______________________________________________________________________________
Int_t TMySQLClient::Connect() {
   // Connect to the MySQL server.
/*
   cout << "+ TMySQLClient::Connect()" << endl;
   stringstream sstr;
   sstr << "mysql://" << this->mysqlserverhost << "/" << this->dbname;
   sqlserv = TSQLServer::Connect(sstr.str().c_str(), this->usr.c_str(), this->pwd.c_str());

   if(sqlserv == NULL) {
      cout << "+ ERROR: Can not connect to the MySql server" << endl;
      return 1;
   }

   isConnected = TRUE;

#if DEBUG_MSG
   cout << GetServerInfo();
#endif
*/
   return 0;
}


//______________________________________________________________________________
Int_t TMySQLClient::Disconnect() {
   // Disconnect from the MySQL server.
   cout << "+ TMySQLClient::Disconnect()" << endl;
/*
   sqlserv->Close();
   isConnected = FALSE;
   */return 0;
}


//______________________________________________________________________________
string TMySQLClient::GetServerInfo() {
   // returns server information.

   stringstream strg;

   strg  << "+ MySQL Server Info: "  << endl
         << "   Version:\t" << sqlserv->ServerInfo() << endl
         << "   Host:\t"    << sqlserv->GetHost()    << endl
         << "   Port:\t"    << sqlserv->GetPort()    << endl
         << "   DB Name:\t" << sqlserv->GetDB()      << endl;

   return strg.str();
}



//______________________________________________________________________________
TSQLResult* TMySQLClient::GetParamTable() {
   // returns a table of all parameter.
   cout << "+ TMySQLClient::GetParamTable()" << endl;

   char sql[400];
   TSQLResult* sqlResult;


   // MySQL query result to receive the parameter description table
   sprintf(sql,
            "'LocalTimeSec', 'SPLC seconds of year', 'HealthStatus', 10, 0, 16, "
            "'uint', '', 909, 1 ");

   sqlResult = sqlserv->Query(sql);


   return sqlResult;
}



//______________________________________________________________________________
void TMySQLClient::PrintSQLResult(TSQLResult* res) {
   // print a sql result table
   cout << "+ TMySQLClient::PrintSQLResult()" << endl;
   cout << "   Field:\t" << res->GetFieldCount() << endl;
   cout << "   Row:\t"   << res->GetRowCount()   << endl;


   // print the field names
   cout << "   | ";
   for(int i=0; i < res->GetFieldCount(); i++) {
      cout << res->GetFieldName(i) << " | ";
   }
   cout << endl;


   // print the table with its data
   TSQLRow *row;
   while ((row = res->Next())) {
      cout << "   | ";
      for(int i=0; i < res->GetFieldCount(); i++) {
         cout << row->GetField(i) << " | ";
      }
      cout << endl;
      delete row;
   }


}



