#ifndef __TMySQLClient__
#define __TMySQLClient__

#include "TObject.h"
#include "TSQLServer.h"

using namespace std;

class TMySQLClient : public TObject {

   public:
      TMySQLClient(string host, string dbname, string usr, string pwd);
      ~TMySQLClient();

   public:
      Int_t Connect();
      Int_t Disconnect();
      string GetServerInfo();
      TSQLResult* GetParamTable();
      void PrintSQLResult(TSQLResult* res); 

   public:
      Bool_t isConnected;     // Is TRUE when the client is connected

   private:
      TSQLServer *sqlserv;       // The MySQL server connection
      string mysqlserverhost;    // mysql server host
      string dbname;  // database name
      string usr;     // user name
      string pwd;     // user password


   ClassDef(TMySQLClient,1)

};


#endif

