#include <stdio.h>
#include <iostream>
#include <stdlib.h>

#include <TGLabel.h>

#include "globalDef.h"
#include "globalData.h"
#include "TTMAnalyserGui.h"
//#include "TTMExtraction.h"

using namespace std;

// IDs for buttons and menu entrys
enum ECommandIdentifiers {
	// Buttons of the toolbar of the onlinemode
	B_TB_START,
	B_TB_STOP,
};

ClassImp(TTMAnalyserGui)

TTMAnalyserGui::TTMAnalyserGui(const TGWindow *p, UInt_t w, UInt_t h){
	// constructor. create the window with its members

	fMainFrame = new TGMainFrame(p, w, h);

	// layouts for objects of different frames
	fTopFrameLayout = new TGLayoutHints(kLHintsTop | kLHintsExpandX);
    fItemLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft, 5, 5, 5, 5);

	// use hierarchical cleaning
	fMainFrame->SetCleanup(kDeepCleanup);

	fMainFrame->Connect("CloseWindow()", "TTMAnalyserGui", this, "CloseWindow()");

// Add tablist to mainframe---------------------------------------------------------------------
	fTab = new TGTab(fMainFrame, 300, 300);
	fTab->Connect("Selected(Int_t)", "TTMAnalyserGui", this, "DoTab(Int_t)");
//----------------------------------------------------------------------------------------------
// Add toolbar + componnets  tablist------------------------------------------------------------
	TGCompositeFrame *tf = fTab->AddTab("Onlinemode");
	fToolFrame = new TGCompositeFrame(tf, 600, 350, kHorizontalFrame);
	
	fStart = new TGPictureButton(fToolFrame, gClient->GetPicture("./icons/play.png"), B_TB_START);
	fStart->Connect("Clicked()", "TTMAnalyserGui", this, "DoButton(Int_t)");
	fStart->SetToolTipText("Start extraction");
	fToolFrame->AddFrame(fStart, fItemLayout);
	
	fStop = new TGPictureButton(fToolFrame, gClient->GetPicture("./icons/stop.png"), B_TB_STOP);
	fStop->Connect("Clicked()", "TTMAnalyserGui", this, "DoButton(Int_t)");
	fStop->SetToolTipText("Stop extraction");
	fToolFrame->AddFrame(fStop, fItemLayout);
	fStop->SetEnabled(FALSE);
	tf->AddFrame(fToolFrame, fTopFrameLayout);

	fMainFrame->AddFrame(fTab, new TGLayoutHints(kLHintsBottom | kLHintsExpandX | kLHintsExpandY, 2, 2, 5, 1));
	
	fMainFrame->SetWindowName("Root Telemetry Analyser");

	fMainFrame->MapSubwindows();
	
	// we need to use GetDefault...() to initialize the layout algorithm...
	fMainFrame->Resize();
	fMainFrame->MapWindow();
	//fMainFrame->Print();
	Connect("Created()", "TTMAnalyserGui", this, "Welcome()");
	Created();
}
TTMAnalyserGui::~TTMAnalyserGui(){

	delete fStart;
	delete fStop;
	delete fTab;
	
	fMainFrame->Cleanup();
	delete fMainFrame;
}
void TTMAnalyserGui::CloseWindow(){
	// close gui.
	sema_gD->Wait();
	gD.extrThrRun_FLAG = EXTRACTION_QUIT;
	sema_gD->Post();
	sema_end->Wait();
	gApplication->Terminate();
}
void TTMAnalyserGui::DoButton(Int_t id){
	// handle buttons by ID.

	if (id == -1) {
      TGButton *btn = (TGButton *) gTQSender;
      id = btn->WidgetId();
   }

	switch(id){
		case B_TB_START:{	
		
			sema_gD->Wait();
			gD.extrThrWork_FLAG = EXTRACTION_WORK_START;
			sema_gD->Post();
			fStart->SetEnabled(FALSE);
			fStop->SetEnabled(TRUE);
		}break;
		case B_TB_STOP:{										

			sema_gD->Wait();						
			gD.extrThrWork_FLAG = EXTRACTION_WORK_STOP;			
			sema_gD->Post();						
			
			int extrThrRun;
			do{
				sema_gD->Wait();
				extrThrRun = gD.extrThrWork_FLAG;
				sema_gD->Post();
				sleep(1);
			}while(extrThrRun != EXTRACTION_WORK_IDLE);
			
			fStart->SetEnabled(TRUE);
			fStop->SetEnabled(FALSE);
		}break;
		
		default: break;
	}
}
void TTMAnalyserGui::DoTab(Int_t id){
	// handle tab items by id.
	//NOTHING TO DO
}
