#ifndef __TTMAnalyserGui__
#define __TTMAnalyserGui__

#include "TTMExtraction.h"

#include <stdlib.h>

#include "TROOT.h"
#include "TApplication.h"
#include "TGClient.h"
#include "TGFrame.h"
#include "RQ_OBJECT.h"
#include <TGMenu.h>
#include <TGButton.h>
#include <TGTab.h>
#include <TGTextEntry.h>
#include <TGStatusBar.h>

#include "TThread.h"

class TTMAnalyserGui{

	RQ_OBJECT("TTMAnalyserGui")

	private:			
		TGMainFrame *fMainFrame;   											// main frame of this widget
		TGCompositeFrame *fToolFrame;										// Frame for the toolbar of the onlinemode
		
		TGTab *fTab;														// Tab to choose different running modi
		TGLayoutHints *fTopFrameLayout, *fItemLayout, *fMenuBarHelpLayout;	// layouts for different objects
		
		TGPictureButton *fStart, *fStop;									// buttons of the toolbar
		
	public:
		TTMAnalyserGui(const TGWindow *p, UInt_t w, UInt_t h);
		virtual ~TTMAnalyserGui();
		
		// slots
		void CloseWindow();
		void DoButton(Int_t id = -1);
		void DoTab(Int_t id);
		
		//*SIGNAL*
		void Created() { Emit("Created()"); } 
		void Welcome() { printf("Gui has been created. Welcome!\n"); }
	
	ClassDef(TTMAnalyserGui,0);
};
#endif
