#include "globalDef.h"
#include "globalData.h"
#include "TTMExtraction.h"

#include "TTree.h"
#include "TSQLRow.h"
#include "TLeaf.h"
#include "TStopwatch.h"

#include <string>
#include <iostream>
#include <iomanip>
#include <stdlib.h>
#include <stdio.h>
#include <netinet/in.h>

#define WRITE_TO_FILE_AFTER_X_PACKETS   10
#define FILE_COMPRESSION                2
#define DEBUG_MSG                       0
#define BENCHMARK                       1
#define BENCHMARK_TO_FILE               0

using namespace std;

ClassImp(TTMExtraction)

//______________________________________________________________________________
TTMExtraction::TTMExtraction(){
   // TTMExtraction constructor.
#if (DEBUG_MSG)
   cout << "+ TTMExtraction::Constructor()" << endl;
#endif
    
	control = new TControlFunctions();  

#if (BENCHMARK_TO_FILE)
   benchFilename.str("");
   benchFilename << "benchmark-comp_" << FILE_COMPRESSION << ".txt";
   benchFileStream.open(benchFilename.str().c_str(),fstream::out);
#endif
}
//______________________________________________________________________________
TTMExtraction::~TTMExtraction() {
   // TTMExtraction destructor.
#if (DEBUG_MSG)
   cout << "+ TTMExtraction::Destructor()" << endl;
#endif
	delete control;
#if (BENCHMARK_TO_FILE)
   benchFileStream.close();
#endif
}
//______________________________________________________________________________
void TTMExtraction::Run(){
   // Start to process incomming Telemetry
#if (DEBUG_MSG)
   cout << "+ TTMExtraction::Run()" << endl;
#endif
	bool doRun = TRUE;
	int doExtract;
  control->Init();
   do{
		sema_gD->Wait();
		doExtract = gD.extrThrWork_FLAG;
		doRun = gD.extrThrRun_FLAG;
		sema_gD->Post();
      if(doExtract == EXTRACTION_WORK_START){
			cout<<"Here happens the real work"<<endl;
			control->SaveRootFile();
			sleep(2);
		}
		else if(doExtract == EXTRACTION_WORK_STOP){
			control->SaveRootFile();
			doExtract = EXTRACTION_WORK_IDLE;
			sema_gD->Wait();
			gD.extrThrWork_FLAG = doExtract;
			sema_gD->Post();
		}
	}while(doRun);
	control->SaveRootFile();
	sema_end->Post();
}
//______________________________________________________________________________
