//#include "globalDef.h"

#include <iostream>
#include <stdlib.h>
#include <signal.h>

#include "TApplication.h"
#include "TGClient.h"
#include "TROOT.h"
#include "TRint.h"
#include "TThread.h"

#include "globalData.h"
#include "TTMExtraction.h"
#include "TTMAnalyserGui.h"

using namespace std; 

globalData gD; 							//create globalData
TSemaphore *sema_gD = new TSemaphore(0);
TSemaphore *sema_end = new TSemaphore(0);

extern void InitGui();
VoidFuncPtr_t initfuncs[] = { InitGui, 0 };
TROOT root("Rint","The ROOT Interactive Interface", initfuncs);

TThread	*extractThr, *guiThr;
void executeMenue();
void initGlobalData();
void *startExtract(void* ptr);
void *startGui(void* ptr);

//______________________________________________________________________________
void ctrlStop(int sig) {
   // Shut down this application in a controlled way
//   cout << "<< Interrupt: exit the application >>" << endl;
   //tmExtract->Stop();
}
//______________________________________________________________________________
void ctrlExit() {
   // Shut down this application in a controlled way
   cout << "+ rootTmAnalyser says goodbye!" << endl;
}
//______________________________________________________________________________
int main(int argc, char **argv)
{
	TApplication theApp("TmAnalyser", &argc, argv);
   bool cint = FALSE;
   initGlobalData();

   // process given program parameter
   for(int i=1; i<argc; i++) {
      // start CINT
      if(strcmp("-cint",argv[i])==0) {
         cint = TRUE;
      }
   }
	
   if(cint) {
      // start CINT interpreter
      TRint *theApp = new TRint("rootTmAnalyser", &argc, argv, NULL, 0);
      theApp->SetPrompt("rtma [%d] ");
      theApp->Run();
   }
   else {

      // set exit function of rootTmAnalyser
      signal(SIGINT, &ctrlStop);
      atexit(&ctrlExit);
	  
	  extractThr = new TThread(startExtract, (void*)1);
	  extractThr->Run();
#if (!FUNTIONAL_VERSION_1)
	  guiThr = new TThread(startGui, (void*)2);
	  guiThr->Run();
	  extractThr->Join();
#endif
#if (FUNTIONAL_VERSION_1)
	  executeMenue();
#endif	  
	  guiThr->Join();
   }
      theApp.Run();
		/*bool close = EXTRACTION_RUN;
		do{
			sema_gD->Wait();
			close = EXTRACTION_QUIT;
			sema_gD->Post();
			sleep(1);
		}while(close ==EXTRACTION_RUN);  */
	 // sema_end->Wait();
	 // sema_end->Wait();
	  //gApplication->Terminate();
   return 0;
}
void executeMenue() {
	// print the text menue and starts the called operation
	int ctrl;

	do{
		cout << " +----------------------------+" << endl;
		cout << " |   Start session      (1)   |" << endl;
		cout << " |   Exit               (2)   |" << endl;
		cout << " +----------------------------+" << endl;
		cout << "> ";
		
		cin.clear();
		if(!(cin >> ctrl) || ctrl > 3 || ctrl <= 0) {
			cout << "+ ERROR: wrong input" << endl;
			ctrl = 0;
			}
			while(getchar() != '\n');
			
			switch (ctrl) {
			case 1 :    sema_gD->Wait();
						gD.extrThrWork_FLAG = EXTRACTION_WORK_START;
						sema_gD->Post();
						break;
			case 2 :    sema_gD->Wait();
						gD.extrThrWork_FLAG = EXTRACTION_WORK_STOP;
						gD.extrThrRun_FLAG = EXTRACTION_QUIT;
						sema_gD->Post();
						sema_end->Wait();
						gApplication->Terminate();
						break;
			default :   continue;
		}
	}while(ctrl != 3);
}
void initGlobalData(){
	// init the variables of globalData (gD) 
	// 
	gD.gDatabaseName = "myDB";
	gD.gFileVersion = 1.0;
	gD.gMySqlServerHost = "localhost";
	gD.gMySqlUserName = "root";
	gD.gMySqlPassword = "mypassw";
	
	gD.extrThrRun_FLAG = EXTRACTION_RUN;
	gD.extrThrWork_FLAG = EXTRACTION_WORK_IDLE;
	
	sema_gD->Post();
}
void *startExtract(void* ptr){
	//function whiche is started as thread and starts the extraction
	
	TTMExtraction *tmExtract = new TTMExtraction();
	tmExtract->Run();
	return 0;
}
void *startGui(void* ptr){
	//function whiche is started as thread and starts the gui
	
	new TTMAnalyserGui(gClient->GetRoot(), 10000, 22000);
	return 0;
}
